readonly NUMARGS=$#
readonly INFOLDER=$1
readonly OUTFOLDER=$2
readonly VNCPORT=$3
readonly VNCPASSWORD=$4
usage() {
echo "USAGE: ./clone.sh base_image_folder out_folder vnc_port vnc_password"
}
makeandcopy() {
mkdir "$OUTFOLDER"
cp "$INFOLDER"/*-000001* "$OUTFOLDER"/
cp "$INFOLDER"/*.vmx "$OUTFOLDER"/
}
main() {
if [ $NUMARGS -le 1 ]
then
usage
exit 1
fi
makeandcopy
local fullbasepath=$(readlink -f "$INFOLDER")/
local fullbasepathout=$(readlink -f "$OUTFOLDER")/
cd "$OUTFOLDER"/
sed -i '/sched.swap.derivedName/d' ./*.vmx #delete swap file line, will be auto recreated
sed -i -e '/displayName =/ s/= .*/= "'$OUTFOLDER'"/' ./*.vmx #Change display name config value
sed -i -e '/RemoteDisplay.vnc.port =/ s/= .*/= "'$VNCPORT'"/' ./*.vmx #Change vnc port
sed -i -e '/RemoteDisplay.vnc.password = / s/= .*/= "'$VNCPASSWORD'"/' ./*.vmx #Change vnc password
local escapedpath=$(echo "$fullbasepath" | sed -e 's/[\/&]/\\&/g')
local escapedpathout=$(echo "$fullbasepathout" | sed -e 's/[\/&]/\\&/g')
sed -i -e '/ide0:0.fileName =/ s/= .*/= "'$escapedpathout'disk-000001.vmdk"/' ./*.vmx #Change vmdk disk path
sed -i -e '/parentFileNameHint=/ s/="/="'"$escapedpath"'/' ./*-000001.vmdk #change parent disk path
# Forces generation of new MAC + DHCP, I think.
sed -i '/ethernet0.generatedAddress/d' ./*.vmx
sed -i '/ethernet0.addressType/d' ./*.vmx
# Forces creation of a fresh UUID for the VM. Obviates the need for the line
# commented out below:
#echo 'answer.msg.uuid.altered="I copied it" ' >>./*.vmx
sed -i '/uuid.location/d' ./*.vmx
sed -i '/uuid.bios/d' ./*.vmx
# Register the machine so that it appears in vSphere.
FULL_PATH=`pwd`/*.vmx
VMID=`vim-cmd solo/registervm $FULL_PATH`
# Power on the machine.
vim-cmd vmsvc/power.on $VMID
}
main
